#!/bin/sh


function traverse () {

for f in `ls` ; do

# handle the hierarchy
	if [ -d "${f}" ] ; then
		pushd $f

# create Makefile for examples
		if expr match `pwd` '.*examples.*' &> /dev/null ; then

# generate general targets
			echo -n "run: " > Makefile
			if ls *.org  &> /dev/null ; then echo -n "eqck-run "   >> Makefile ; fi
			if ls *.vhdl &> /dev/null ; then echo -n "vhdlFE-run " >> Makefile ; fi
			echo  >> Makefile

			for g in `ls` ; do
				if [ -d "${g}" ] ; then
					cat >> Makefile << EOF
	cd $g; make
EOF
				fi
			done

			echo  >> Makefile

			echo -n "clean: " >> Makefile
			if ls *.org  &> /dev/null ; then echo -n "eqck-clean "   >> Makefile ; fi
			if ls *.vhdl &> /dev/null ; then echo -n "vhdlFE-clean " >> Makefile ; fi
			echo  >> Makefile

			for g in `ls` ; do
				if [ -d "${g}" ] ; then
					cat >> Makefile << EOF
	cd $g; make clean
EOF
				fi
			done
		fi

		traverse "../${1}"
		popd
	fi

# generate Makefile for examples
	if expr match `pwd` '.*examples.*' &> /dev/null ; then


# generate lines for equivalence checking
		if [ -f "${f}" ] && expr match "${f}" '.*\.org$' &> /dev/null ; then
			desB=`basename ${f} .org` ;
			echo "design for verification is $desB (from $f)" ;
			cat >> Makefile << EOF

eqck-run: ${desB}-report.txt ${desB}.org.pdf ${desB}.schd.pdf

${desB}-report.txt: ${desB}.org ${desB}.schd
	${1}/verifier ${desB}.org ${desB}.schd > report.txt

${desB}.org.pdf: ${desB}.org.dot
	dot -Tpdf ${desB}.org.dot > ${desB}.org.pdf

${desB}.schd.pdf: ${desB}.schd.dot
	dot -Tpdf ${desB}.schd.dot > ${desB}.schd.pdf

eqck-clean:
	rm -f ${desB}-report.txt ${desB}.org.pdf ${desB}.schd.pdf ${desB}.org.dot ${desB}.schd.dot
EOF

    	fi



# generate lines for vhdlFE
		if [ -f "${f}" ] && expr match "${f}" '.*\.vhdl$' &> /dev/null ; then
			desB=`basename ${f} .vhdl` ;
			echo "design for vdhlFE is $desB (from $f)" ;
			cat >> Makefile << EOF

vhdlFE-run: ${desB}.cdfg  ${desB}-1.po  ${desB}-1_hdl


${desB}.cdfg: ${desB}.vhdl
	${1}/vhdlFE ${desB} 

${desB}-1.po: ${desB}.cdfg
	${1}/cdfg   ${desB}

${desB}-1_hdl ${desB}-1.schd: ${desB}-1.po
	${1}/gsh    ${desB} 


vhdlFE-clean:
	rm -f ${desB}.arch ${desB}.cdfg ${desB}.opr ${desB}.step ${desB}-1.bb \\
	${desB}-1.opr ${desB}-1.po ${desB}-1*_hdl  ${desB}-1.*.out \\
	${desB}-1.*.stat ${desB}-1.schd sols

EOF

		fi
	fi

done

}

traverse "${1}"
