--------------------------------------------------------------------------------
--
-- Differential Equation Benchmark
--
-- Source: Adapted from example in paper
--        "HAL: A Multi-Paradigm Approach to Automatic Data Path Synthesis"
--         by P. Paulin, J. Knight and E. Girczyc
--         23rd DAC, June 1986, pp. 263-270
--
-- Benchmark author: Joe Lis
--
--    Copyright (c) 1989 by Joe Lis 
-- 
-- Modified by Champaka Ramachandran on Aug 17th 1992 
--
-- Verification Information:
--
--                  Verified     By whom?           Date         Simulator
--                  --------   ------------        --------     ------------
--  Syntax            yes   Champaka Ramachandran  17th Aug 92    ZYCAD
--  Functionality     yes   Champaka Ramachandran  17th Aug 92    ZYCAD
--------------------------------------------------------------------------------

entity diffeq is
   port (p1: in integer;
         p2: in integer;
         p3: in integer;
         p4: out integer;
         p5: out integer);
end diffeq;

--VSS: design_style BEHAVIORAL

architecture diffeq of diffeq is

begin

Procc : process (p1, p2, p3)

   variable dx,x,y, u, a: integer ;
   variable v0,v1,v2,v3,v4,v5,v6 : integer ;

begin

  dx := p1;  x := p2; y := p1; u := p2; a := p3;
  
   while (x < a) loop

      	v0 := u*dx;
		v1 := 3*x;
		x  := x+dx;
		v2 := v0*v1;
		v3 := 3*y;
		v4 := u-v2;
		v5 := dx*v3;
		v6 := u*dx;
		u  := v4-v5;
		y  := y+v6;


   end loop;

  p4 <= x;
  p4 <= u;
  p5 <= y;

end process Procc;

end diffeq;
